<?php

	require_once 'class.Program.php';
	require_once 'class.Picture.php';
	require_once 'class.Matrix.php';
	require_once 'class.ListFile.php';
	require_once 'class.List.php';
	require_once 'class.Version.php';
	
	class Project {
		var $name;
		var $description;
		var $version;
		
		var $elements;
		
		public function __construct($n, $d = '', $v = NULL){
			$this->name = $n;
			$this->description = $d;
			$this->version = $v;
		}
		public function addData($elem){
			$this->elements[] = $elem;
		}
		public function addProgram($program){
			if( $program instanceof Program ){
				$this->elements[] = $program;
			}
		}
		public function addPicture($picture){
			if( $picture instanceof CtPicture ){
				$this->elements[] = $picture;
				//echo "toto".NL;
			}
		}
		
		
		
		public function getPrograms(){
			$programs = array();
			foreach( $this->elements as $element ){
				if( $element instanceof Program ){
					$programs[] = $element;
				}
			}
			return $programs;
		}
		public function getMatrix(){
			$matrix = array();
			foreach( $this->elements as $element ){
				if( $element instanceof Matrix ){
					$matrix[] = $element;
				}
			}
			return $matrix;
		}
		public function getPictures(){
			$pictures = array();
			foreach( $this->elements as $element ){
				if( $element instanceof CtPicture ){
					$pictures[] = $element;
				}
			}
			return $pictures;
		}
		public function getLists(){
			$lists = array();
			foreach( $this->elements as $element ){
				if( $element instanceof CtList ){
					$lists[] = $element;
				}
			}
			return $lists;
		}
		
		public function getName(){
			return $this->name;
		}
		public function getAll(){
			return $this->elements;
		}
		
	}

?>