<?php

	class G1rReader {
	
		function __construct($path){
			$this->filePath = $path;
		}
		
		private function readHeader($fileSize){
			$header = "\xaa\xac\xbd\xaf\x90\x88\x9a\x8d\xce\xff\xef\xff\xef\xff";
			$fileSizeCheckByte = 190 - $fileSize % 256;
			if( $fileSizeFirstCheckByte < 0 ){
				$fileSizeFirstCheckByte += 256;
			}
			$header .= chr($fileSizeCheckByte);
			// file size is written over 4 bytes but i don't know
			// data files bigger than 100 Mo so a 16 Mo limit is not a problem
			$header .= "\xfe\xff";
			
			$fileSizeCheck = 0xFFFFFF - $fileSize;
			$header .= chr($fileSizeCheck >> 16);
			$header .= chr($fileSizeCheck >> 8);
			$header .= chr($fileSizeCheck & 0xff);
			
			$fileSizeSecondCheckByte = 71 - $fileSize % 256;
			$header .= chr($fileSizeSecondCheckByte);

			
			// 9 * 0x00
			$header .= "\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff";
			$header .= chr(0xff - $nbElements);
		}
		
		private $bufferReader;
		
		private function readNext(){
			/*
			 * SETUP
			 */
			if( $buffer->startsWith('SETUP') ){
				// goto end
				$buffer->moveCursor(144);
			}
			
			/*
			 * ALPHA MEMORY
			 */
			if( $buffer->startsWith('ALPHAMEM') ){
				// goto data block
				$buffer->moveCursor(44);
				// 29 * 24 bytes
				for( $i = 0 ; $i < 29 ; $i++ ){
					// just move the cursor
					$buffer->moveCursor(24);
				}
			}
			
			if( $buffer->startsWith('PROGRAM') ){
			}
			
			if( $buffer->startsWith('PICTURE') ){
				$buffer->moveCursor(32);
				
				$nbDigits = 0;
				$id = 0;
				while( ( $byte = $buffer->getByte() ) != 0 ){
					$id = $id * 10 + $byte - 48;
					$nbDigits++;
				}
				$buffer->moveCursor(2 - $nbDigits);
				$buffer->moveCursor(26);
				
				$x = 1;
				$y = 64;
				$p = new CtPicture($id);
				for( $i = 0 ; $i < 1024 ; $i++ ){
					$byte = ord($data[$index++]);
					for( $bit = 0 ; $bit < 8 ; $bit++ ){
						if( ($byte & 0x01) == 1 ){
							$p->setPixel(0, $x + 7 - $bit, 65 - $y);
						}
						$byte = $byte >> 1;
					}
					if( ($x += 8) > 128 ){
						$x = 1;
						$y--;
					}
				}
				$buffer->moveCursor(1008);
			}
						
		}
		
		public static function pathToProjectName($path){
			if( is_string($path) ){
				return preg_replace("/[^a-zA-Z0-9\\._\\-]/i", "_", $path);
			}
			return '';
		}		
		
		public static function getProjectFromFile($path){
			$data = file_get_contents($path);
			$buffer = new BufferReader($data);
			$project = new Project(pathToProjectName($path));
			
			$buffer->moveCursor(32);
			
			
		}
	}

?>