<?php

	/**
	 * @french
	 * Une classe qui permet de lire des char, short, long, et double depuis une chaine de caractres.
	 * @endfrench
	 * @author Adrien
	 *
	 */
	class BufferReader{
		
		const READ_MODE_BIG_ENDIAN = 1;
		const READ_MODE_LITTLE_ENDIAN = 2;

		private $length;
		private $bytes;
		private $cursor;
		private $readMode;
		
		/**
		 * 
		 * @param String La chane de caractre
		 */
		public function __construct($str){
			if( is_string($str) ){
				$this->length = strlen($str);
				$this->bytes = $str;
			} else {
				$this->bytes = '';
				$this->length = 0;
			}

			$this->cursor = 0;
		}

		public function addBytes($str){
			if( is_string($str) ){
				$this->bytes += $str;
				$this->length += strlen($str);
			}
		}
		
		public function getSize(){
			return $this->length;
		}
		
		public function getNextByte(){
			return ord($this->bytes[$this->cursor++]);
		}
		
		public function getNextShort(){
			if( $this->cursor + 2 <= $this->length ){
				return 256 * ord($this->bytes[$this->cursor++]) +
					ord($this->bytes[$this->cursor++]);
			}
			return NULL;
		}
		
		public function getNextLong(){
			if( $this->cursor + 4 <= $this->length ){
				return 256 * 256 * 256 * ord($this->bytes[$this->cursor++]) +
				256 * 256 * ord($this->bytes[$this->cursor++]) +
				256 * ord($this->bytes[$this->cursor++]) +
				ord($this->bytes[$this->cursor++]);
			}
			return NULL;
		}
	}

?>