<?php

	/**
	 * @var array
	 * Contains a map that links the class name to the file path
	 */
	$classes = array(
		// Data
		'CtPictures'		=> 'Data/class.Pictures.php',
		'Color'				=> 'Data/class.Color.php',
		'ColorFormat'		=> 'Data/class.ColorFormat.php',
		'Data'				=> 'Data/class.Data.php',
		'List'				=> 'Data/class.List.php',
		'ListFile'			=> 'Data/class.ListFile.php',
		'Matrix'			=> 'Data/class.Matrix.php',
		'Number'			=> 'Data/class.Number.php',
		'Picture'			=> 'Data/class.Picture.php',
		'Program'			=> 'Data/class.Program.php',
		'Project'			=> 'Data/class.Project.php',
		'Variable'			=> 'Data/class.Variable.php',
		'Version'			=> 'Data/class.Version.php',
	
		// IO
		'CatWriter'			=> 'IO/class.CatWriter.php',
		'FileWriter'		=> 'IO/class.FileWriter.php',
		'FxiReader'			=> 'IO/class.FxiReader.php',
		'FxiWriter'			=> 'IO/class.FxiWriter.php',
		'G1mReader'			=> 'IO/class.G1mReader.php',
		'G1rReader'			=> 'IO/class.G1rReader.php',
	
		// Others
		'BufferReader'		=> 'Others/class.BufferReader.php'
	);

	/**
	 * Function called when a new object is created and its class hasn't been defined.
	 * Include the file that contains the class to define. In this way, if you don't need a class,
	 * it won't be defined.
	 * @param string $className The class of the new object
	 * @throws Exception An exception that indicates the class in unknwon.
	 */
	
	function myAutoload($c){
		echo isset($classes) ? 'true' : 'false';
	}
	
/*	function __autoload($className){

	}
*/
	class ClassesRegisterSingleton {
		public static $registeredClasses = null;
		public static $instance = null;
		
		public function __construct(){
		}
				
		public static function init($classes){
			self::$registeredClasses = $classes;
		}
		
		public static function autoload($className){
			if( array_key_exists($className, self::$registeredClasses) ){
				include self::$registeredClasses[$className];
			} else {
				throw new Exception('Unknown class name ['.$className.']');
			}
		}
	}
	
	ClassesRegisterSingleton::init($classes);
	
//	$MyClassesManager = new ClassesRegisterSingleton($classes);
	spl_autoload_register(array('ClassesRegisterSingleton', 'autoload'));
//	spl_autoload_register('myAutoload');
	
/*	try{
	$reader = new G1rReader();
	}
	catch ( Exception $e ){
		echo htmlentities($e->getMessage());
	}*/

?>